function [Ehat,Re,gamma,E,Rr,delta,r]=lat_mar07_09(M,y,lambda)

n = length(y);
y = [0; y];

prot        =   zeros(M+3,n+3);
E           =   prot;
Ehat        =   prot;
r           =   prot;
Re          =   prot;
Rr          =   prot;
gamma       =   prot;
delta       =   prot;

for t=0:n-1,
    tt = t+2;
    %initialization
    E(2,tt) = y(tt);
    r(2,tt) = y(tt);
    Re(2,tt) = lambda*Re(2,tt-1) + y(tt)^2;
    Rr(2,tt) = Re(2,tt);
    gamma(1,tt) = 1;
    
    for k=0:(min(M,t)-1),
        kk = k+2;
        
        if abs(gamma(kk-1,tt-1))~=0,
            delta(kk+1,tt) = lambda*delta(kk+1,tt-1) + E(kk,tt)*r(kk,tt-1)/gamma(kk-1,tt-1);
        else
             delta(kk+1,tt) = delta(kk+1,tt-1);
        end

        if abs(Rr(kk,tt))~=0,
            gamma(kk,tt) = gamma(kk-1,tt) - r(kk,tt)^2/Rr(kk,tt);
        else
            gamma(kk,tt) = gamma(kk-1,tt);
        end

        if abs(Rr(kk,tt-1))~=0,
            E(kk+1,tt) = E(kk,tt) - delta(kk+1,tt)*r(kk,tt-1)/Rr(kk,tt-1);
            Re(kk+1,tt) = Re(kk,tt) - delta(kk+1,tt)^2/Rr(kk,tt-1);
        else
            E(kk+1,tt) = E(kk,tt);
            Re(kk+1,tt) = Re(kk,tt);
        end

        if abs(Re(kk,tt))~=0,
            r(kk+1,tt) = r(kk,tt-1) - delta(kk+1,tt)*E(kk,tt)/Re(kk,tt);
            Rr(kk+1,tt) = Rr(kk,tt-1) - delta(kk+1,tt)^2/Re(kk,tt);
        else
            r(kk+1,tt) = r(kk,tt-1); 
            Rr(kk+1,tt) = Rr(kk,tt-1);
        end

        if abs(gamma(kk,tt-1))~=0,
            Ehat(kk+1,tt) = E(kk+1,tt)/gamma(kk,tt-1);
        else
            Ehat(kk+1,tt) = 0;
        end
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ehat(2,:) = E(2,:);
Ehat = Ehat(2:end-1,2:end-2);

 for j=1:2,
    Ehat(2:end,j)=Ehat(1,j);
 end
  for j=3:M+1,
    Ehat(j:end,j)=Ehat(j-1,j);
  end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Re = Re(2:end-1,2:end-2);
[II,JJ] = find(Re==0); 
 for index=1:length(II),
     Re(II(index),JJ(index)) = 1;
 end
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
gamma = gamma(1:end-2,1:end-3);
[II,JJ] = find(gamma==0);
for index=1:length(II),
    gamma(II(index),JJ(index)) = 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
E = E(2:end-1,2:end-2);
for j=1:2,
    E(2:end,j) = E(1,j);
end
for j=3:M+1,
    E(j:end,j)=E(j-1,j);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Rr = Rr(2:end-1,2:end-2);
[II,JJ] = find(Rr==0);
for index=1:length(II),
    Rr(II(index),JJ(index)) = 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
delta = delta(2:end-1,2:end-2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r = r(2:end-1,2:end-2);


